#
# spec file for package dapl2
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           dapl2
Summary:        A Library for userspace access to RDMA devices using OS Agnostic DAT APIs.
Url:            www.openfabrics.org
Version:        2.0.30
Release:        0.12.1
License:        BSD 3-Clause; GPL v2 or later
Group:          System/Libraries
Source0:        dapl-%{version}.tar.bz2
Patch1:         dapl-2.0.30-mod-dat-conf-in-rpm.patch
Patch2:         dapl-2.0.30-dat_ia_open-hang.patch
Patch3:         dapl2-bnc#642445.patch
Patch4:         dapl-correctly_map_EINTR.patch
Patch5:         dapl2-fix_type_punning.patch
Patch6:         realigned-disconnect.patch
Patch7:         cma-fix-debug-build-issue.patch
BuildRequires:  libibverbs-devel
BuildRequires:  librdmacm-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExcludeArch:    s390 s390x

%description
Along with the OpenFabrics kernel drivers, libdat and libdapl provides
a userspace RDMA API that supports DAT 2.0 specification and IB
transport extensions for atomic operations and rdma write with
immediate data.



Authors:
--------
    Caitlin Bestler
    Philip Christopher
    Jay Danielsen
    Arlin Davis
    Tom Duffy
    Matthew Finlay
    Jimmy Hill
    James Lentini
    Gil Rubin
    Steve Sears
    Randy Smith
    Stan Smith
    Anthony Topper
    Steve Wise

%package devel
License:        BSD 3-Clause; GPL v2 or later
Summary:        A Library for userspace access to RDMA devices using OS Agnostic DAT APIs.
Group:          System/Libraries
Requires:       %{name} = %{version}
#libdaplofa.la requires libpthread.so
Requires:       glibc-devel
Requires:       libibverbs-devel
Requires:       librdmacm-devel

%description devel
Along with the OpenFabrics kernel drivers, libdat and libdapl provides
a userspace RDMA API that supports DAT 2.0 specification and IB
transport extensions for atomic operations and rdma write with
immediate data.



Authors:
--------
    Caitlin Bestler
    Philip Christopher
    Jay Danielsen
    Arlin Davis
    Tom Duffy
    Matthew Finlay
    Jimmy Hill
    James Lentini
    Gil Rubin
    Steve Sears
    Randy Smith
    Stan Smith
    Anthony Topper
    Steve Wise

%package        doc
License:        BSD 3-Clause; "GPLv2 or later, CPLv1.0, BSD 3 Clause ..."; GPL v2 or later
Group:          System/Libraries
Summary:        A Library for userspace access to RDMA devices using OS Agnostic DAT APIs
Requires:       %{name} = %{version}
Provides:       dapl_man

%description doc
Along with the OpenFabrics kernel drivers, libdat and libdapl provides
a userspace RDMA API that supports DAT 2.0 specification and IB
transport extensions for atomic operations and rdma write with
immediate data.



Authors:
--------
    Caitlin Bestler
    Philip Christopher
    Jay Danielsen
    Arlin Davis
    Tom Duffy
    Matthew Finlay
    Jimmy Hill
    James Lentini
    Gil Rubin
    Steve Sears
    Randy Smith
    Stan Smith
    Anthony Topper
    Steve Wise

%prep
%setup -q -n dapl-%{version}
%patch1 -p1
%patch2 -p1
%patch3
%patch4
%patch5
%patch6 -p1
%patch7 -p1

%build
%{expand: %%define optflags %{optflags} -D_GNU_SOURCE}
%configure
make

%install
%makeinstall
mkdir -p %{buildroot}%{_sysconfdir}
touch %{buildroot}%{_sysconfdir}/dat.conf

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig
if test -e %{_sysconfdir}/dat.conf; then
	sed -i -e '/ofa-v2-.* u2/d' %{_sysconfdir}/dat.conf
fi
cat <<EOF >>%{_sysconfdir}/dat.conf
ofa-v2-ib0 u2.0 nonthreadsafe default libdaplofa.so.2 dapl.2.0 "ib0 0" ""
ofa-v2-ib1 u2.0 nonthreadsafe default libdaplofa.so.2 dapl.2.0 "ib1 0" ""
ofa-v2-ib2 u2.0 nonthreadsafe default libdaplofa.so.2 dapl.2.0 "ib2 0" ""
ofa-v2-ib3 u2.0 nonthreadsafe default libdaplofa.so.2 dapl.2.0 "ib3 0" ""
ofa-v2-bond u2.0 nonthreadsafe default libdaplofa.so.2 dapl.2.0 "bond0 0" ""
EOF

#On update save configuration before uninstall of old package runs
if [ $1 -gt 0 ]; then
	cp -p %_sysconfdir/dat.conf %_sysconfdir/dat.conf.rpmtmp
fi

%posttrans
if [ -e "%_sysconfdir/dat.conf.rpmtmp" ]; then
  mv %_sysconfdir/dat.conf.rpmtmp %_sysconfdir/dat.conf
fi

%postun
/sbin/ldconfig
if test -e %{_sysconfdir}/dat.conf; then
	sed -i -e '/ofa-v2-.* u2/d' %{_sysconfdir}/dat.conf
fi

%files
%defattr(-, root, root)
%{_bindir}/*
%{_libdir}/libdaplofa.so.*
%{_libdir}/libdaploscm.so.*
%{_libdir}/libdaploucm.so.*
%{_libdir}/libdat2.so.*
%config %ghost %{_sysconfdir}/dat.conf

%files devel
%defattr(-, root, root)
%{_includedir}/dat2/
%{_libdir}/libdaplofa.a
%{_libdir}/libdaplofa.la
%{_libdir}/libdaplofa.so
%{_libdir}/libdaploscm.a
%{_libdir}/libdaploscm.la
%{_libdir}/libdaploscm.so
%{_libdir}/libdaploucm.a
%{_libdir}/libdaploucm.la
%{_libdir}/libdaploucm.so
%{_libdir}/libdat2.a
%{_libdir}/libdat2.la
%{_libdir}/libdat2.so

%files doc
%defattr(-, root, root)
%_mandir/man1/*
%_mandir/man5/*

%changelog
* Tue Mar  8 2011 pth@suse.de
- Don't remove the configuration for this dapl version on update
  (bnc#676731).
- Use cat instead of multiple echos.
- Include /etc/dat.conf as %%config %%ghost.
* Fri Mar  4 2011 pth@suse.de
- Fix tmp race in post/postun (bnc#676700).
* Mon Feb  7 2011 pth@suse.de
- Sync PTF with normal package.
* Thu Dec 16 2010 pth@suse.de
- Add patch to fix dapl_ep_disconnect() not observing proper behavior
  (bnc#656702).
* Wed Dec  1 2010 jsembera@suse.de
- realigned-disconnect.patch fixing bnc#656702
- added cma-fix-debug-build-issue.patch fixing debug build
- remove Obsoletes: again, we don't need it as we separated manpages
  into their own packages
* Fri Nov 26 2010 pth@suse.de
- Split off man pages into their own sub package that can be
  required by dapl.
- Fix type-punning in test app so that we don't need
  - fno-strict-aliasing allowing better code optimisation.
* Thu Nov 25 2010 pth@suse.de
- Let the caller detect EINTR (bnc#655518).
- Add explicit requires for glibc-devel to dapl2-devel.
- Fix type punning in test suite
- Define _GNU_SOURCE to get pthread_yield declared.
* Wed Nov 24 2010 jsembera@suse.de
- Add dapl-correctly_map_EINTR.patch fixing bnc#655518
  EINTR is not properly mapped to DAT_INTERRUPTED_CALL
* Tue Nov 23 2010 jsembera@suse.de
- Adjusted obsoletes to obsolete dapl < 2.0
* Fri Nov 12 2010 pth@suse.de
- Add the patch for dapl/openib_cma/cm.c mentioned in bnc#642445.
* Tue Oct 26 2010 jsembera@suse.de
- PTF for 642445
  Version upgrade based on home:jjolly:branches:SUSE:SLE-10-SP3:Update:Test
* Thu Oct 21 2010 stefan.fent@novell.com
- Updated to v 2.0.30 from OFED 1.5.2
- rediffed dat.conf patch
- added patch for bnc #647915
* Thu Jun 10 2010 jsembera@suse.de
- PTF for 604678
  Version upgrade based on home:jjolly:branches:SUSE:SLE-10-SP3:Update:Test
* Mon May 24 2010 jjolly@novell.com
- Updated to v2.0.27 from OFED 1.5.1
- Refactored dat.conf patch
- Added libdaploucm.* files
* Fri Nov 13 2009 jjolly@suse.de
- Updated to dapl v2.0.19 from OFED 1.4.1 release (bnc#551008)
* Thu Oct 16 2008 jjolly@suse.de
- Updated to dapl v2.0.9 from OFED 1.3.1 release
- Moved /etc/dat.conf mod into rpm %%post script
* Thu Mar 27 2008 jjolly@suse.de
- Removing test/dtest/GETOPT.H and GETOPT.C to avoid possible
  licensing problems (#369655)
* Mon Mar  3 2008 jjolly@suse.de
- Initial submission of dapl v2.0.7 from OFED 1.3 GA release
